@subheading gsasl_property_set
@anchor{gsasl_property_set}
@deftypefun {void} {gsasl_property_set} (Gsasl_session * @var{sctx}, Gsasl_property @var{prop}, const char * @var{data})
@var{sctx}: session handle.

@var{prop}: enumerated value of Gsasl_property type, indicating the
type of data in @code{data}.

@var{data}: zero terminated character string to store.

Make a copy of @code{data} and store it in the session handle for the
indicated property @code{prop}.

You can immediately deallocate @code{data} after calling this function,
without affecting the data stored in the session handle.

@strong{Since:} 0.2.0
@end deftypefun

@subheading gsasl_property_set_raw
@anchor{gsasl_property_set_raw}
@deftypefun {void} {gsasl_property_set_raw} (Gsasl_session * @var{sctx}, Gsasl_property @var{prop}, const char * @var{data}, size_t @var{len})
@var{sctx}: session handle.

@var{prop}: enumerated value of Gsasl_property type, indicating the
type of data in @code{data}.

@var{data}: character string to store.

@var{len}: length of character string to store.

Make a copy of @code{len} sized @code{data} and store a zero terminated version
of it in the session handle for the indicated property @code{prop}.

You can immediately deallocate @code{data} after calling this function,
without affecting the data stored in the session handle.

Except for the length indicator, this function is identical to
gsasl_property_set.

@strong{Since:} 0.2.0
@end deftypefun

@subheading gsasl_property_fast
@anchor{gsasl_property_fast}
@deftypefun {const char *} {gsasl_property_fast} (Gsasl_session * @var{sctx}, Gsasl_property @var{prop})
@var{sctx}: session handle.

@var{prop}: enumerated value of Gsasl_property type, indicating the
type of data in @code{data}.

Retrieve the data stored in the session handle for given property
@code{prop}.

The pointer is to live data, and must not be deallocated or
modified in any way.

This function will not invoke the application callback.

@strong{Return value:} Return property value, if known, or NULL if no value
known.

@strong{Since:} 0.2.0
@end deftypefun

@subheading gsasl_property_get
@anchor{gsasl_property_get}
@deftypefun {const char *} {gsasl_property_get} (Gsasl_session * @var{sctx}, Gsasl_property @var{prop})
@var{sctx}: session handle.

@var{prop}: enumerated value of Gsasl_property type, indicating the
type of data in @code{data}.

Retrieve the data stored in the session handle for given property
@code{prop}, possibly invoking the application callback to get the value.

The pointer is to live data, and must not be deallocated or
modified in any way.

This function will invoke the application callback, using
@code{gsasl_callback()}, when a property value is not known.

If no value is known, and no callback is specified or if the
callback fail to return data, and if any obsolete callback
functions has been set by the application, this function will try
to call these obsolete callbacks, and store the returned data as
the corresponding property.  This behaviour of this function will
be removed when the obsolete callback interfaces are removed.

@strong{Return value:} Return data for property, or NULL if no value known.

@strong{Since:} 0.2.0
@end deftypefun

